﻿package {
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.*;
	import flash.display.Stage;
	import flash.display.StageAlign;

	import flash.display.Shape;
	import flash.geom.Point;
	import flash.events.*;
	import flash.utils.Timer;
	import flash.text.*;
	
	import flash.display.LoaderInfo;
	import flash.display.StageDisplayState;
	
	import Hexagon;
	import Play;
	import InfoBox;
	
	public class Hexagonfield extends Sprite{
		
		public var hexArr:Array = [];
		private var tf:TextField;
		private var radius:Number;
		private var count:Number = 0;
		private var movieToggle:Play;
		private var infoBox:InfoBox;
		private var data:Array;
		private var geneNames:Array;
		private var colorScheme:Boolean = colorScheme_replace;
		
		public function Hexagonfield(){
		
			tf = new TextField();
			addChild(tf);
			
			radius = 28.6;

			fillData();
		
			var i:Number;
			var j:Number;
			
			var counting:Number = 0;
			
			for (i=0; i<xvaluereplace; i++){
				for (j=0; j<yvaluereplace; j++){
					
					var hex:Hexagon = new Hexagon(this, data[counting], colorScheme);
					addChild(hex);
					hex.setPos(270 + i*radius*0.80+20, 30 + 0.83*j*radius+(i%2)*24/2);
					hex.setRadius(radius);
					
					hex.setText(geneNames[counting]);
					
					hex.refreshGraphics();
					hexArr[counting] = hex;
					
					counting++;
				}
			}
			
			infoBox = new InfoBox(this);
			infoBox.y = 50;
			addChild(infoBox);
			
			movieToggle = new Play(this);
			movieToggle.y = 160;
			addChild(movieToggle);
			movieToggle.drawPlay();
			
		}
		
		public function setFrame(_frame:Number){
			var i:Number = 0;
			
			for(i=0;i<hexArr.length;i++){
				hexArr[i].setFrame(_frame);
			}
		}
		
		public function setText(_txt:String):void{
			removeChild(tf);
			
			var format:TextFormat = new TextFormat();
			format.font = "Arial";
			format.color = 0x000000;
			format.size = 26;
			format.bold = true;
			tf = new TextField();
			tf.defaultTextFormat = format;
			tf.text = _txt;
			var temptextlength:Number = tf.textWidth;
			tf.x = 0;
			tf.y = 10;
			tf.height = 40;
			tf.width = 26 * _txt.length;
			tf.mouseEnabled = false;
			
			addChild(tf);
		}
		
		public function feedBack(_name:String, _data:Array){
			infoBox.setData(_data);
			setText(_name);
		}
		
		private function fillData(){
			data = new Array();
			geneNames = new Array();
			
			data_array_replace
			
		}
	}
}
